from abc import ABC, abstractmethod


class AuthenticationUser(ABC):
    @abstractmethod
    async def has_permission(self, permission):
        pass

    @abstractmethod
    async def has_capacity(self, version, name):
        pass


class AuthenticationBackend(ABC):
    @abstractmethod
    async def get_user(self, token):
        pass


class DummyAuthenticationUser(AuthenticationUser):
    async def has_permission(self, permission):
        return True

    async def has_capacity(self, version, name):
        return True


class DummyAuthenticationBackend(AuthenticationBackend):
    async def get_user(self, token):
        return DummyAuthenticationUser()
