import contextvars
import logging
from collections import defaultdict

logger = logging.getLogger(__name__)

client = None
server = None
handlers = defaultdict(lambda: defaultdict(dict))

token = contextvars.ContextVar("token")
user = contextvars.ContextVar("user")


def get_handlers():
    global handlers
    return handlers


def add_handler(version, name, handler):
    global handlers
    handlers[version][name] = handler


def get_client():
    global client
    return client


def set_client(client_new):
    global client
    client = client_new


def get_server():
    global server
    return server


def set_server(server_new):
    global server
    server = server_new


def get_token():
    global token
    return token.get()


def set_token(token_new):
    global token
    token.set(token_new)


def get_user():
    global user
    return user.get()


def set_user(user_new):
    global user
    user.set(user_new)
