from dataclasses import dataclass


@dataclass
class Handler:
    version: int
    permission: str
    function: callable
    name: str
    parameters: object
    documentation: str
    format: int
    schema_in: object
    schema_out: object
    data_length_max: int
    timeout: int
    allow_deferred: bool

    def __init__(
        self,
        *,
        version,
        permission,
        function,
        name,
        parameters,
        documentation,
        format,
        schema_in=None,
        schema_out=None,
        data_length_max=None,
        timeout=None,
        allow_deferred=False,
    ):
        self.version = version
        self.permission = permission
        self.function = function
        self.name = name
        self.parameters = parameters
        self.documentation = documentation
        self.format = format
        self.schema_in = schema_in
        self.schema_out = schema_out
        self.data_length_max = data_length_max
        self.timeout = timeout
        self.allow_deferred = allow_deferred
